TA23065 = {};
print("  TA23065 loaded");
function TA23065.prerequisitesPresent(specializations)
return SpecializationUtil.hasSpecialization(Trailer, specializations) and SpecializationUtil.hasSpecialization(AnimatedVehicle, specializations);
    
end;

function TA23065:load(xmlFile)

	
	
	self.isActor = false;
	self.setachsverschiebung = SpecializationUtil.callSpecializationsFunction("setachsverschiebung");
	local achse = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.achse#index"));
	if achse ~= nil then
		self.achse = {};
		self.achse.node = achse;
		local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.achse#minRot"));
		self.achse.minRot = {};
		self.achse.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
		self.achse.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
		self.achse.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
		x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.achse#maxRot"));
		self.achse.maxRot = {};
		self.achse.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
		self.achse.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
		self.achse.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
		self.achse.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.achse#rotTime"), 1)*1000;
		self.supportTrans1 = {};
		self.supportTrans1.node = achse;
		local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.achse#minTrans"));
		self.supportTrans1.minRot = {};
		self.supportTrans1.minRot[1] = x;
		self.supportTrans1.minRot[2] = y;
		self.supportTrans1.minRot[3] = z;
		x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.achse#maxTrans"));
		self.supportTrans1.maxRot = {};
		self.supportTrans1.maxRot[1] = x;
		self.supportTrans1.maxRot[2] = y;
		self.supportTrans1.maxRot[3] = z;
		self.supportTrans1.rotTime = self.achse.rotTime;
	end;
	self.smokeParticleSystems = {};
    local entry = {};
      entry.ps = {};
      Utils.loadParticleSystem(xmlFile, entry.ps, "vehicle.smokeParticleSystem", self.components, false, nil, self.baseDirectory);
      if table.getn(entry.ps) > 0 then
          entry.isActive = false;
          table.insert(self.smokeParticleSystems, entry);
      end
      local i=0;
      while true do
          local baseName = string.format("vehicle.smokeParticleSystems.smokeParticleSystem(%d)", i);
          if not hasXMLProperty(xmlFile, baseName) then
              break;
          end;
          local entry = {};
          entry.ps = {};
          Utils.loadParticleSystem(xmlFile, entry.ps, baseName, self.components, false, nil, self.baseDirectory);
          if table.getn(entry.ps) > 0 then
              entry.isActive = false;
             entry.cuttingArea = i+1;
              table.insert(self.smokeParticleSystems, entry);
          end
          i = i+1;
      end;
	
	self.achserear = false;
	self.achsefront = true;
	
	
end;

function TA23065:delete()
	for _, entry in ipairs(self.smokeParticleSystems) do
          Utils.deleteParticleSystem(entry.ps);
          entry.isActive = false;
	end;
end;

function TA23065:readStream(streamId, connection)
	
end;

function TA23065:writeStream(streamId, connection)
	
end;

function TA23065:mouseEvent(posX, posY, isDown, isUp, button)

end;

function TA23065:keyEvent(unicode, sym, modifier, isDown)

end;

function TA23065:update(dt)
	
	local pro = self.capacity / 100;
		local percent = self.fillLevel/(self.capacity/100);

		if achsefront then
 
 
		if percent <= 50.0 then  
			achsefront = false;
			self.achserear = false;
			achsverschiebungEvent.sendEvent(self, self.achserear);
		end;
  
		else

		if percent > 50.0 then 
			achsefront = true;
			self.achserear = true;
			achsverschiebungEvent.sendEvent(self, self.achserear);
		end;
    
	end; 	
	
end;

function TA23065:updateTick(dt)
		if self.achserear ~= nil then	
			if self.achserear then
				local x, y, z = getTranslation(self.supportTrans1.node);
				local trans = {x,y,z};
				local newTrans = Utils.getMovedLimitedValues(trans, self.supportTrans1.maxRot, self.supportTrans1.minRot, 3, self.supportTrans1.rotTime, dt, true);
				setTranslation(self.supportTrans1.node, unpack(newTrans));
				if math.abs(self.supportTrans1.minRot[1]-newTrans[1]) < 0.001 then
					local x, y, z = getRotation(self.achse.node);
					local rot = {x,y,z};
					local newRot = Utils.getMovedLimitedValues(rot, self.achse.maxRot, self.achse.minRot, 3, self.achse.rotTime, dt, true);
					setRotation(self.achse.node, unpack(newRot));
				end;
			else
				local x, y, z = getRotation(self.achse.node);
				local rot = {x,y,z};
				local newRot = Utils.getMovedLimitedValues(rot, self.achse.maxRot, self.achse.minRot, 3, self.achse.rotTime, dt, false);
				setRotation(self.achse.node, unpack(newRot));
				if math.abs(self.achse.maxRot[1]-newRot[1]) < 0.001 then
					local x, y, z = getTranslation(self.supportTrans1.node);
					local trans = {x,y,z};
					local newTrans = Utils.getMovedLimitedValues(trans, self.supportTrans1.maxRot, self.supportTrans1.minRot, 3, self.supportTrans1.rotTime, dt, false);
					setTranslation(self.supportTrans1.node, unpack(newTrans));
				end;
			end;
			for i, jointDesc in pairs(self.componentJoints) do
				setJointFrame(self.componentJoints[i].jointIndex, 0, self.componentJoints[i].jointNode);
			end;
		end;
	
	if self.fillLevel > 0 then
	    if self.currentFillType == Fillable.FILLTYPE then
			self:setAddedParts(0);			
		end;              
	end;

		if self.isClient then
               for _,ps in pairs(self.smokeParticleSystems) do                  
                  if self.currentFillType == Fillable.FILLTYPE_MANURE and self.fillLevel > 3000 and self.movingDirection == 0 then                       
                      Utils.setEmittingState(ps.ps, true);
                  else
                      Utils.setEmittingState(ps.ps, false);
                  end
               end
		end;

	
end;



function TA23065:setTowballDirection()
	
end;

function TA23065:onAttach(attacherVehicle)
	
end;

function TA23065:readStream(streamId, connection)
	self.achserear = streamReadBool(streamId);
end;

function TA23065:writeStream(streamId, connection)
	streamWriteBool(streamId, self.achserear);
end;

function TA23065:onDetach()
	
	if not self.achserear then
			self.achserear = not self.achserear;
			achsverschiebungEvent.sendEvent(self, self.achserear);
		end;

	if self.deactivateOnDetach then
        self:onDeactivate(self);
    else
        self:onDeactivateSounds(self);
    end;
	
end;

function TA23065:draw()
		
		
end;



